import React, { useEffect, useRef, useState } from 'react';
import { renderToBody } from './render-to-body';
export function renderImperatively(element) {
  let close = () => {};

  const Wrapper = () => {
    const [visible, setVisible] = useState(false);
    const closedRef = useRef(false);
    useEffect(() => {
      if (!closedRef.current) {
        setVisible(true);
      } else {
        afterClose();
      }
    }, []);

    function onClose() {
      var _a, _b;

      closedRef.current = true;
      setVisible(false);
      (_b = (_a = element.props).onClose) === null || _b === void 0 ? void 0 : _b.call(_a);
    }

    close = onClose;

    function afterClose() {
      var _a, _b;

      unmount();
      (_b = (_a = element.props).afterClose) === null || _b === void 0 ? void 0 : _b.call(_a);
    }

    return React.cloneElement(element, Object.assign(Object.assign({}, element.props), {
      visible,
      onClose,
      afterClose
    }));
  };

  const unmount = renderToBody(React.createElement(Wrapper, null));
  return {
    close
  };
}